# start x on first session
if [[ -z $DISPLAY ]] && [[ $(tty) = /dev/tty1 ]]; then
    {{ (desktop_environment == 'sway') | ternary('exec sway || startx', 'startx') }}
fi

# stop here if not in interactive mode
[[ $- != *i* ]] && return

# don't put duplicate lines or lines starting with space in the history.
HISTCONTROL=ignoreboth
HISTTIMEFORMAT="%m-%d %T "
HISTSIZE=20000
HISTFILESIZE=20000

# append to the history file in real-time, don't overwrite it
shopt -s histappend
PROMPT_COMMAND="history -a; $PROMPT_COMMAND"

# check the window size after each command and, if necessary,
# update the values of LINES and COLUMNS.
shopt -s checkwinsize

parse_git_dirty() {
  [[ $(git status --porcelain 2> /dev/null) ]] && echo "*"
}

parse_git_branch() {
  git branch --no-color 2> /dev/null | sed -e '/^[^*]/d' -e "s/* \(.*\)/ (\1$(parse_git_dirty))/"
}

kcontext() {
  local current_context
  current_context=$(kubectl config current-context 2>/dev/null) \
  && echo "(⎈ $current_context)"
}

PS1="\[\033[32m\]\w\
\[\033[33m\]\$(parse_git_branch)\[\033[00m\] \
\[\033[94m\]\$(kcontext)\[\033[00m\] \
$ "

# alias commands
alias ls="ls --color"
alias dir="dir --color=auto"
alias grep="grep --color=auto"
alias ip="ip -c"

alias g="git status"
alias ac="git add . && git commit -m '...'"
alias gps="git push"
alias gpl="git pull"
alias gl="git log -p"

alias v="nvim"
# alias vim="nvim"

alias up="~/rust-maintenance/target/release/rust-maintenance"
alias setup="bash ~/.autosetup.sh"

alias k="kubectl"
source <(kubectl completion bash)
complete -o default -F __start_kubectl k

# short alias to set/show context/namespace (only works for bash and bash-compatible shells, current context to be set before using kn to set namespace)
alias kx='f() { [ "$1" ] && kubectl config use-context $1 || kubectl config current-context ; } ; f'
alias kn='f() { [ "$1" ] && kubectl config set-context --current --namespace $1 || kubectl config view --minify | grep namespace | cut -d" " -f6 ; } ; f'

alias mk="minikube"

KUBECONFIG=
for file in ~/.kube/*yaml; do
  KUBECONFIG="$KUBECONFIG:$file"
done

gc ()
{
    git clone "${1//github.com/$GIT_TOKEN@github.com}"
}
export -f gc


kindcluster ()
{
kind delete cluster && kind create cluster --config - <<EOF
kind: Cluster
apiVersion: kind.x-k8s.io/v1alpha4
nodes:
  - role: control-plane
  - role: control-plane
  - role: worker
  - role: worker
EOF
kubectl cluster-info --context kind-kind
}
export -f kindcluster

export PATH=$PATH:/usr/local/go/bin:~/go/bin

source "$HOME/.cargo/env"

alias live="bash ~/stepwise/live"
alias tf="terraform"
alias tfd="terraform destroy -auto-approve"
alias tfa="terraform plan && terraform apply -auto-approve"

export dry="--dry-run=client -o yaml"
export do="--dry-run=client -o yaml"

command -v flux >/dev/null && . <(flux completion bash)

# security: make all user files private
umask 077

### python virtual env cd hook
check_venv() {
  if [[ -n "$VIRTUAL_ENV" && "$PWD"/ != "$(dirname "$VIRTUAL_ENV")"* ]]; then
    deactivate
  elif [[ -d ./venv ]]; then
    source ./venv/bin/activate
  fi
}
cd() {
  builtin cd "$@" && check_venv
}
check_venv
### python virtual env cd hook
